<?php

/*
* pdf2swf pour PHP 5
* franck ruzzin
* 02 jan 2010
*/

class Pdf2swf
{
	//Chemin de pdf2swf avec "/" terminal
	private $pdftoolsPath;
	
	/**
	* Constructeur
	*/
	function __construct()
	{
		$serverOS=strtoupper($_ENV['OS']);
		$pos = strpos($serverOS, "WINDOWS");
		//Le systeme du serveur n'est pas Windows
		if ($pos === false) {
			$this->pdftoolsPath='../';
		} else {
		//Le systeme du serveur est  Windows
			$this->pdftoolsPath='..\\';
		}
	}
	
	/**
	* Destructeur (appel implicitement lorsque l'objet est dtruit)
	*/
	function __destruct() {
        //echo "Pdf2swf Object libr\n";
    }
		
	/**
	* Mthode pour convertir pour convertir un PDF en SWF
	* @param string $pdfFilePath chemin complet vers le fichier PDF
	* @param string $swfFilePath chemin complet vers le fichier SWF
	* @return boolean "true" si le fichier existe, "false" sinon ou s'il y a un problme de paramtre
	*/
	public function convert($pdfFilePath,$swfFilePath)
	{	
		$output=array();
		try {
			//si le fichier PDF est plus ancien que le fichier SWF. Donc le SWF requis existe dj.
			if (!$this->isPdfNewer($pdfFilePath,$swfFilePath)) {
				array_push ($output, utf8_encode("Fichier de sortie dj existant, OK"));
				array_push ($output, "EXEC RETURN VALUE : 0");
				return $this->arrayToString($output);
			}
		} catch (Exception $ex) {
			array_push ($output, utf8_encode($ex->getMessage()));
			array_push ($output, "EXEC RETURN VALUE : 1");
			return $this->arrayToString($output);
			
			//return $ex->getMessage();
		}
	
		// Supprimer l'ventuel fichier
        //if (file_exists($swfFilePath)) unlink($swfFilePath);
		// Cration d'un SWF  partir d'un PDF  
		$command = $this->pdftoolsPath . 'pdf2swf ' . $pdfFilePath . ' -o ' . $swfFilePath . ' -s internallinkfunction=handleInternalLink -T 9';
		$return_var=0;
		exec($command,$output,$return_var);
		array_push ($output, "EXEC RETURN VALUE : " . $return_var);
		$s=$this->arrayToString($output);
		
		//if (!file_exists($swfFilePath)) return $s;
		return $s;
	}
	
	
	/**
	* Methode pour dterminer si le fichier PDF est plus rcent que le fichier SWF
	* @param string $pdfFilePath chemin complet du fixhier PDF
	* @param string $swfFilePath chemin complet du fixhier SWF
	* @return boolean "true" si le fihier SWF est inexistant ou si le PDF est plus rcent que la SWF, "false" sinon.
	*/
	private function isPdfNewer($pdfFilePath,$swfFilePath)
	{
		if (!file_exists($pdfFilePath)) {
			throw new Exception("Ne trouve pas $pdfFilePath");
		}
		if ($swfFilePath==null) {
			throw new Exception("Nom du fichier de sortie non fix");
		} else {
			if (!file_exists($swfFilePath)) {
				return true;
			} else {
				if (filemtime($pdfFilePath)>filemtime($swfFilePath)) return true;
			}
		}
		return false;
	}
	
	/**
	* Transforme un simple tableau en une chane d'lments avec retour  la ligne
	* @param array $result_array le tableau  traiter
	* @return String la chane reprsentant le tableau "aplati"
	*/
	private function arrayToString($result_array) {
		reset($result_array);
		$s="";
		while ($array_cell=each($result_array)) {
			$s .= "->" . $array_cell['value'] . chr(10) ;
		}
		return $s;
	}
	
	
}

?>